precision mediump float;

uniform highp mat4 mvp;
uniform highp float inFadeIn;
uniform float  inBackingScaleFactor;
uniform float  inTime;
in highp vec4  inPosition;
in highp vec2  inTexcoord;
in float  inColorIndex;
in highp float  inRelMag;
in float inTwinklePhase;
in float inTwinkleMag;
in float inTwinkleFreq;
out highp float relMag;
out highp float colorIndex;
out highp float fadeIn;
out highp float twinkle;
out lowp float starShaped;

void main (void)
{
	float pointSize;
	
	gl_Position	= mvp * inPosition;
	
	pointSize = inRelMag;
	pointSize = smoothstep(7.0,1.8,inRelMag);
	pointSize *= 4.0;
	pointSize += 1.0;
	starShaped = step(4.8, pointSize);
	
	float twinkleMul = 1.0 + (inTwinkleMag * (sin((inTime + inTwinklePhase) * inTwinkleFreq)));
	
	pointSize *= ((starShaped * 0.4) + 1.0);
	pointSize *= inBackingScaleFactor;
	
	gl_PointSize = pointSize;
	
	colorIndex = inColorIndex;
	relMag = inRelMag;
	fadeIn = inFadeIn;
	twinkle = twinkleMul;
}

